<template>
  <div class="sidebar-content">
    <div class="sidebar-slot">
      <JTabsBody v-model="chatCreateType">
        <JTabBodyItem>
          <slot />
        </JTabBodyItem>
        <JTabBodyItem>
          <Transition>
            <CreatingGroupChat v-if="chatCreateType === ChatCreateTypes.Group" />
          </Transition>
        </JTabBodyItem>
        <JTabBodyItem>
          <Transition>
            <CreatingPrivateChat v-if="chatCreateType === ChatCreateTypes.Private" />
          </Transition>
        </JTabBodyItem>
        <JTabBodyItem>
          <Transition>
            <CreatingGroupChatFinalStep v-if="chatCreateType === ChatCreateTypes.GroupFinalStep" />
          </Transition>
        </JTabBodyItem>
      </JTabsBody>
    </div>
  </div>
</template>

<script setup lang="ts">
import { defineAsyncComponent, onUnmounted } from 'vue';
import { JTabsBody, JTabBodyItem } from '@new-jira-clone/ui/src/components';
import useCreatingChatState from '../model/useCreatingChatState';
import { ChatCreateTypes } from '../model/createChat.enum';

const CreatingGroupChat = defineAsyncComponent(() => import('./CreatingGroupChat.vue'));
const CreatingPrivateChat = defineAsyncComponent(() => import('./CreatingPrivateChat.vue'));
const CreatingGroupChatFinalStep = defineAsyncComponent(() => import('./CreatingGroupChatFinalStep.vue'));

const { chatCreateType, $reset } = useCreatingChatState();

onUnmounted(() => {
  $reset();
});
</script>

<style scoped lang="scss">
.sidebar-content {
  display: flex;
  position: relative;
  width: 100%;
}

.sidebar-slot {
  min-width: 100%;
  max-width: 100%;
  height: 100%;
}

.v-enter-active,
.v-leave-active {
  transition-duration: 300ms;
}
</style>
